﻿using System;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;
using WinMapSamples.Properties;

namespace WinMapSamples
{
    public partial class Main : Form
    {
        public Main()
        {
            InitializeComponent();
        }

        private void Main_Load(object sender, EventArgs e)
        {
            // set map unit
            winformsMap1.MapUnit = GeographyUnit.DecimalDegree;
            ShapeFileFeatureLayer countriesLayer = new ShapeFileFeatureLayer(@"..\..\App_Data\Countries02.shp");

            BlinkingAreaStyle blinkingStyle = new BlinkingAreaStyle();
            blinkingStyle.FillBrushes.Add(GeoBrushes.Red);
            blinkingStyle.FillBrushes.Add(GeoBrushes.Green);
            blinkingStyle.FillBrushes.Add(GeoBrushes.Blue);
            countriesLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(blinkingStyle);
            countriesLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay staticOverlay = new LayerOverlay() { AutoRefreshInterval = TimeSpan.FromSeconds(5) };
            staticOverlay.Layers.Add("CountriesLayer", countriesLayer);
            winformsMap1.Overlays.Add("BlinkingOverlay", staticOverlay);

            // set map extent
            winformsMap1.CurrentExtent = new RectangleShape(-139.2, 90, 120.9, -90);
            winformsMap1.OverlaysDrawing += winformsMap1_OverlaysDrawing;
            winformsMap1.OverlaysDrawn += winformsMap1_OverlaysDrawn;
          
            winformsMap1.Refresh();
        }

        void winformsMap1_OverlaysDrawn(object sender, OverlaysDrawnWinformsMapEventArgs e)
        {
            winformsMap1.Overlays["BlinkingOverlay"].AutoRefreshInterval = TimeSpan.FromSeconds(5);
        }

        void winformsMap1_OverlaysDrawing(object sender, OverlaysDrawingWinformsMapEventArgs e)
        {
            winformsMap1.Overlays["BlinkingOverlay"].AutoRefreshInterval = TimeSpan.Zero;
        }

    }
}
